package de.thk.gm.websocketsdemo.configs

import de.thk.gm.websocketsdemo.handlers.ChatRoomsHandler
import de.thk.gm.websocketsdemo.handlers.EchoHandler
import de.thk.gm.websocketsdemo.handlers.SimpleChatHandler
import de.thk.gm.websocketsdemo.services.ChatMessageService
import de.thk.gm.websocketsdemo.services.ChatRoomsService
import org.springframework.context.annotation.Configuration
import org.springframework.web.socket.WebSocketHandler
import org.springframework.web.socket.config.annotation.EnableWebSocket
import org.springframework.web.socket.config.annotation.WebSocketConfigurer
import org.springframework.web.socket.config.annotation.WebSocketHandlerRegistry

@Configuration
@EnableWebSocket
class WebSocketsConfig(private val chatMessageService: ChatMessageService, private val chatRoomsService: ChatRoomsService): WebSocketConfigurer {
    override fun registerWebSocketHandlers(registry: WebSocketHandlerRegistry) {
        registry.addHandler(EchoHandler(), "/echo").setAllowedOrigins("*")
        registry.addHandler(SimpleChatHandler(), "/chat")
        registry.addHandler(ChatRoomsHandler(chatRoomsService, chatMessageService),"/rooms")
    }
}