package de.thk.gm.websocketsdemo.controllers

import de.thk.gm.websocketsdemo.dtos.ChatRoomDto
import de.thk.gm.websocketsdemo.models.ChatRoom
import de.thk.gm.websocketsdemo.services.ChatMessageService
import de.thk.gm.websocketsdemo.services.ChatRoomsService
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.web.bind.annotation.*
import java.util.*

@Controller
@RequestMapping("/chatrooms")
class ChatRoomsController (private val chatRoomsService: ChatRoomsService, private val chatMessageService: ChatMessageService) {

    @GetMapping
    fun getChatRooms(model: Model): String {
        model.addAttribute("chatRooms", chatRoomsService.getChatRooms())
        return "chatRooms/showChatRooms"
    }

    @PostMapping
    fun addChatRoom(chatRoomDto: ChatRoomDto): String {
        var chatRoom = ChatRoom()
        chatRoom.name = chatRoomDto.name
        chatRoomsService.save(chatRoom)
        return "redirect:/chatrooms/${chatRoom.id}"
    }

    @GetMapping("/{id}")
    fun getChatRoom(@PathVariable("id") id: UUID, model: Model): String {

        var chatRoom = chatRoomsService.getChatRoomById(id)
        var chatMessages = chatMessageService.getChatMessagesByChatRoomId(id)
        model.addAttribute("chatRoom", chatRoom)
        model.addAttribute("chatMessages", chatMessages)
        return "chatRooms/showChatRoom"
    }
}