package de.thk.gm.websocketsdemo.services

import de.thk.gm.websocketsdemo.models.ChatMessage
import de.thk.gm.websocketsdemo.repositories.ChatMessageRepository
import de.thk.gm.websocketsdemo.repositories.ChatRoomsRepository
import org.springframework.stereotype.Service
import java.util.*

@Service
class ChatMessageServiceImpl (private val chatMessageRepository: ChatMessageRepository, private val chatRoomsRepository: ChatRoomsRepository) : ChatMessageService {
    override fun getChatMessagesByChatRoomId(roomId: UUID): List<ChatMessage> {
        val chatRoom = chatRoomsRepository.findById(roomId).orElse(null)
        if(chatRoom != null) {
            return chatMessageRepository.findChatMessagesByChatRoomOrderByCreatedAt(chatRoom)
        } else {
            return listOf()
        }

    }

    override fun save(chatMessage: ChatMessage) {
       chatMessageRepository.save(chatMessage)
    }
}