package de.thk.gm.websocketsdemo.services

import de.thk.gm.websocketsdemo.models.ChatRoom
import de.thk.gm.websocketsdemo.repositories.ChatRoomsRepository
import org.springframework.stereotype.Service
import java.util.*

@Service
class ChatRoomsServiceImpl (private val chatRoomsRepository: ChatRoomsRepository) : ChatRoomsService {
    override fun getChatRooms(): List<ChatRoom> {
        return chatRoomsRepository.findAll().toList()
    }

    override fun getChatRoomById(id: UUID): ChatRoom? {
        return chatRoomsRepository.findById(id).orElse(null)
    }

    override fun save(chatRoom: ChatRoom) {
        chatRoomsRepository.save(chatRoom)
    }
}